defstar {
	name { XYMgraph }
	derivedFrom { XMgraph }
	domain { SDF }
	desc {
Generates an X-Y plot with the pxgraph program.
The X data is on "xInput" and the Y data is on "input".
	}
	version {@(#)SDFXYMgraph.pl	1.0 15/04/98}
	author { F. Schilder }
	copyright {
Copyright (c) 1990-1997 by Frank Schilder. All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { SDF user defined library }
	htmldoc {
The input signal is plotted using the <i>pxgraph</i> program, with one
input interpreted as the x-axis data, and the other input as y-axis data.
<a name="graph, X-Y"></a>
<a name="pxgraph program"></a>
	}
	seealso {Xgraph XMgraph $PTOLEMY/src/pxgraph/pxgraph.htm Xhistogram}
	input {
		name { xInput }
		type { anytype }
	}
	constructor {
		// make xInit and xUnits invisible
		xUnits.setAttributes(A_NONSETTABLE);
		xInit.setAttributes(A_NONSETTABLE);
	}
	go {
		MPHIter nexti(input);
		for (int i = 1; i <= input.numberPorts(); i++) {
                    graph.addPoint(i, float(xInput%0), float((*nexti++)%0));
		}

//		graph.addPoint(float(xInput%0), float(input%0));
	}
}
