defstar {
	name {filter}
	domain {SDF}
        desc {
digital filter:
This Star computes the slided avarage over 2^n-1 input
values where n is the number of bits of the (integral)
output value and rescales its value between -U_ref and
+U_ref.
        }
        version {@(#)SDFfilter.pl	1.0 AUG/6/98}
	author { F. Schilder }
	copyright {
Copyright (c) 1998 by Frank Schilder. All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { A/D converter simulation package }

        input {
            name { xInput }
            type { float }
 	}
        output {
            name { sigOut }
            type { float }
	}
        ccinclude { <iostream.h> }
	state {
            name { bits }
            default { "4" }
            type { int }
            desc { bit depht }
            attributes { A_CONSTANT | A_SETTABLE }
        }
	state {
            name { U_ref }
            default { "1.0" }
            type { float }
            desc { reference current }
            attributes { A_CONSTANT | A_SETTABLE }
        }
        private {
            double *X, *ptr, sum;
            int count, dim;
        }
        constructor {
            X=0;
        }
        destructor {
            if(X != 0) delete [] X;
        }
        setup {
            if(bits <= 1)
                Error::abortRun(*this, "too less bit depth (bits<=1)");
            dim = 1;
            dim <<= bits;
            if(X != 0) delete [] X;
            ptr = X = new double[ (count = --dim) ];
            sum = 0.0;
        }
	go {
           if( count==0 ) {
               if( ptr == X+dim ) ptr = X;
               sum -= *ptr;
               sum += ( *ptr++ = double(xInput%0) );
           } else {
               sum += ( *ptr++ = double(xInput%0) );
               count --;
           }
           sigOut%0 << double(U_ref)*( 2.0*sum / (double)dim - 1.0);
	}
}
